//---------------------------------------------------------------------------
//How is this originaly written in verilog, and what made someone thing it would divide by a big number instead of just 2

module clock_div
(
  input wire clock_200MHz,
  output wire clk_a_reset
);

//---------------------------------------------------------------------------
//Wire declarations

  wire clk_a_div_c;
  wire clk_a_div_d;
  wire clk_a_div_a;
  wire clk_a_div_out15, clk_a_div_out14, clk_a_div_out13, clk_a_div_out12, clk_a_div_out11, clk_a_div_out10, clk_a_div_out9, clk_a_div_out8, clk_a_div_out7, clk_a_div_out6, clk_a_div_out5, clk_a_div_out4, clk_a_div_out3, clk_a_div_out2, clk_a_div_out1, clk_a_div_out0;
  wire clk_a_div_b;

//---------------------------------------------------------------------------
//Register declarations

  reg clk_a_div_reg6  = 0;
  reg clk_a_div_reg13 = 0;
  reg clk_a_div_reg14 = 0;
  reg clk_a_div_reg5  = 0;
  reg clk_a_div_reg0  = 0;
  reg clk_a_div_reg1  = 0;
  reg clk_a_div_reg3  = 0;
  reg clk_a_div_reg4  = 0;
  reg clk_a_div_reg10 = 0;
  reg clk_a_div_reg7  = 0;
  reg clk_a_div_reg11 = 0;
  reg clk_a_div_reg12 = 0;
  reg clk_a_div_reg15 = 0;
  reg clk_a_div_reg8  = 0;
  reg clk_a_div_reg9  = 0;
  reg clk_a_div_reg2  = 0;

//---------------------------------------------------------------------------
//Block 589, LSLICE 3

  assign clk_a_div_c = (clk_a_div_b & ~clk_a_div_reg9 & ~clk_a_div_reg8 & ((~clk_a_div_reg7 & ~clk_a_div_reg6)));
  assign clk_a_reset = (~(clk_a_div_d & clk_a_div_c));

  always @(posedge clock_200MHz)
  begin
    if(clk_a_reset == 1'b1)
    begin
      clk_a_div_reg6 <= 1'b0;
      clk_a_div_reg13 <= 1'b0;
    end
    else
    begin
      clk_a_div_reg6 <= clk_a_div_out6;
      clk_a_div_reg13 <= clk_a_div_out13;
    end
  end

//---------------------------------------------------------------------------
//Block 626, LSLICE 3

  assign clk_a_div_d = (clk_a_div_a & ~clk_a_div_reg15 & ~clk_a_div_reg14 & ((~clk_a_div_reg13 & ~clk_a_div_reg12)));
  assign clk_a_div_a = (~clk_a_div_reg1 & ~clk_a_div_reg10 & ((~clk_a_div_reg11 & ~clk_a_div_reg0)));

//b0 = 0, b1 = 0, b10 = 0, b11 = 0 ==> _a = 1
//b0 = 1                           ==> _a = 0

  always @(posedge clock_200MHz)
  begin
    if(clk_a_reset == 1'b1)
    begin
      clk_a_div_reg14 <= 1'b0;
      clk_a_div_reg5 <= 1'b0;
    end
    else
    begin
      clk_a_div_reg14 <= clk_a_div_out14;
      clk_a_div_reg5 <= clk_a_div_out5;
    end
  end

//---------------------------------------------------------------------------
//Block 627, LSLICE 2

  always @(posedge clock_200MHz)
  begin
    if(clk_a_reset == 1'b1)
    begin
      clk_a_div_reg0 <= 1'b0;
      clk_a_div_reg1 <= 1'b0;
    end
    else
    begin
      clk_a_div_reg0 <= clk_a_div_out0;
      clk_a_div_reg1 <= clk_a_div_out1;
    end
  end

//---------------------------------------------------------------------------
//Block 628, LSLICE 3

  always @(posedge clock_200MHz)
  begin
    if(clk_a_reset == 1'b1)
    begin
      clk_a_div_reg3 <= 1'b0;
      clk_a_div_reg4 <= 1'b0;
    end
    else
    begin
      clk_a_div_reg3 <= clk_a_div_out3;
      clk_a_div_reg4 <= clk_a_div_out4;
    end
  end

//---------------------------------------------------------------------------
//Block 630, LSLICE 2

  always @(posedge clock_200MHz)
  begin
    if(clk_a_reset == 1'b1)
    begin
      clk_a_div_reg10 <= 1'b0;
      clk_a_div_reg7 <= 1'b0;
    end
    else
    begin
      clk_a_div_reg10 <= clk_a_div_out10;
      clk_a_div_reg7 <= clk_a_div_out7;
    end
  end

//---------------------------------------------------------------------------
//Block 631, LSLICE 3

  always @(posedge clock_200MHz)
  begin
    if(clk_a_reset == 1'b1)
    begin
      clk_a_div_reg11 <= 1'b0;
      clk_a_div_reg12 <= 1'b0;
    end
    else
    begin
      clk_a_div_reg11 <= clk_a_div_out11;
      clk_a_div_reg12 <= clk_a_div_out12;
    end
  end

//---------------------------------------------------------------------------
//Block 632, LSLICE 2

  always @(posedge clock_200MHz)
  begin
    if(clk_a_reset == 1'b1)
    begin
      clk_a_div_reg15 <= 1'b0;
      clk_a_div_reg8 <= 1'b0;
    end
    else
    begin
      clk_a_div_reg15 <= clk_a_div_out15;
      clk_a_div_reg8 <= clk_a_div_out8;
    end
  end

//---------------------------------------------------------------------------
//LSICE adder blocks 627, 628, 630, 631, 632

  assign { clk_a_div_out15, clk_a_div_out14, clk_a_div_out13, clk_a_div_out12, clk_a_div_out11, clk_a_div_out10, clk_a_div_out9, clk_a_div_out8, clk_a_div_out7, clk_a_div_out6, clk_a_div_out5, clk_a_div_out4, clk_a_div_out3, clk_a_div_out2, clk_a_div_out1, clk_a_div_out0 } = { clk_a_div_reg15, clk_a_div_reg14, clk_a_div_reg13, clk_a_div_reg12, clk_a_div_reg11, clk_a_div_reg10, clk_a_div_reg9, clk_a_div_reg8, clk_a_div_reg7, clk_a_div_reg6, clk_a_div_reg5, clk_a_div_reg4, clk_a_div_reg3, clk_a_div_reg2, clk_a_div_reg1, clk_a_div_reg0 } + { 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b0, 1'b1 };

//---------------------------------------------------------------------------
//Block 629, MSLICE 0

  always @(posedge clock_200MHz)
  begin
    if(clk_a_reset == 1'b1)
    begin
      clk_a_div_reg9 <= 1'b0;
    end
    else
    begin
      clk_a_div_reg9 <= clk_a_div_out9;
    end
  end

//---------------------------------------------------------------------------
//Block 676, MSLICE 0

  assign clk_a_div_b = (~clk_a_div_reg5 & ~clk_a_div_reg4 & ((~clk_a_div_reg3 & ~clk_a_div_reg2)));

  always @(posedge clock_200MHz)
  begin
    if(clk_a_reset == 1'b1)
    begin
      clk_a_div_reg2 <= 1'b0;
    end
    else
    begin
      clk_a_div_reg2 <= clk_a_div_out2;
    end
  end

endmodule

